"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ArrayIncludes = ArrayIncludes;
exports.polyfill = polyfill;
exports.default = void 0;

/* eslint-disable no-bitwise, no-extend-native, radix, no-self-compare, consistent-this */
// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/includes
function ArrayIncludes(searchElement) {
  var O = Object(this);
  var len = parseInt(O.length) || 0;

  if (len === 0) {
    return false;
  }

  var n = parseInt(arguments[1]) || 0;
  var k;

  if (n >= 0) {
    k = n;
  } else {
    k = len + n;

    if (k < 0) {
      k = 0;
    }
  }

  var currentElement;

  while (k < len) {
    currentElement = O[k];

    if (searchElement === currentElement || searchElement !== searchElement && currentElement !== currentElement) {
      return true;
    }

    k++;
  }

  return false;
}
/**
 * polyfill ES7 Array
 */


function polyfill() {
  var ArrayConstructor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Array;

  if (!ArrayConstructor.prototype.includes) {
    Object.defineProperty(ArrayConstructor.prototype, 'includes', {
      enumerable: false,
      writable: true,
      configurable: true,
      value: ArrayIncludes
    });
  }
}

exports["default"] = module.exports;
var _default = module.exports;
exports.default = _default;