"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isInteger = isInteger;
exports.isNaN = isNaN;
exports.polyfill = polyfill;
exports.default = void 0;
// https://github.com/dherman/tc39-codex-wiki/blob/master/data/es6/number/index.md
var globalIsNaN = isNaN;
var globalIsFinite = isFinite;
var floor = Math.floor;

function isInteger(value) {
  return typeof value === 'number' && globalIsFinite(value) && value > -9007199254740992 && value < 9007199254740992 && floor(value) === value;
}

function isNaN(value) {
  return typeof value === 'number' && globalIsFinite(value);
}
/**
 * polyfill Number
 */


function polyfill() {
  var NumberConstructor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Number;

  if (NumberConstructor.EPSILON === undefined) {
    Object.defineProperty(NumberConstructor, 'EPSILON', {
      value: Math.pow(2, -52)
    });
  }

  if (NumberConstructor.MAX_SAFE_INTEGER === undefined) {
    Object.defineProperty(NumberConstructor, 'MAX_SAFE_INTEGER', {
      value: Math.pow(2, 53) - 1
    });
  }

  if (NumberConstructor.MIN_SAFE_INTEGER === undefined) {
    Object.defineProperty(NumberConstructor, 'MIN_SAFE_INTEGER', {
      value: -(Math.pow(2, 53) - 1)
    });
  }

  if (!NumberConstructor.isNaN) {
    definePty(NumberConstructor, 'isNaN', isNaN);
  }

  if (!NumberConstructor.isFinite) {
    definePty(NumberConstructor, 'isFinite', isNaN);
  }

  if (!NumberConstructor.isInteger) {
    definePty(NumberConstructor, 'isInteger', isInteger);
  }
}

function definePty(obj, key, val) {
  Object.defineProperty(obj, key, {
    value: val,
    configurable: true,
    enumerable: false,
    writable: true
  });
}

exports["default"] = module.exports;
var _default = module.exports;
exports.default = _default;